/* --- Copyright University of Birmingham 2007. All rights reserved. ------
 > File:			 $usepop/pop/lib/ved/ved_highlight.p
 > Purpose:			
 > Author:			Aaron Sloman, Nov 22 2007
 > Documentation:
 > Related Files:
 */

section;

;;; items not to be highlighted (edit if you wish)
global vars
	highlight_exceptions =
        [% "(", ")", "[", "]", "{", "}", ";", ":", ",", ".", "%",
			"->", """, "^", "^^", "!" %];

define ved_highlight;

    ;;; save current position;
    vedpositionpush();

    ;;; jump to top of file
    vedtopfile();
    ;;; highlight every syntax word in file

    repeat
        quitif(vedatend());
        lvars item = vedmoveitem();
        if is_syntax_word(item)
        and not(lmember(item, highlight_exceptions))
        then
            ;;; underline item just read
            ;;; (change 'u' to 'b' for bold)
            veddo('chat -w u');
        endif;
    endrepeat;

    ;;; jump to saved position
    vedpositionpop();
enddefine;

endsection;
